<?php
#------------------------------------------
#          Plugin para WDTV Live
# Series Series.ly - Acceso mediante API
#------------------------------------------

include('funciones.php');
include('funciones-seriesly.php');


function _pluginMain($prmQuery) {

	$auth_token=file_get_contents('http://series.ly/api/auth.php?api=16&secret=7F3Ff9PeVu7ch3vTPZ93');
	$user_token=@file_get_contents('/tmp/serieslyusertoken');
	$mi_cookie =@file_get_contents('/tmp/serieslycookie');

	$logado=file_get_contents('http://series.ly/api/isUserLogged.php?auth_token='.$auth_token.'&user_token='.$user_token);
	if ( $logado == 0 ) {
  	$user_token=_NosLogamos();
  }

	$website = 'http://series.ly/series/index.php';
	$plugin = 'series-seriesly-api';
	$queryData = array();
	parse_str($prmQuery, $queryData);



	if ($queryData['inicio'] =='Siguiendo') { 
  	$url = 'http://series.ly/api/userSeries.php?auth_token='.$auth_token.'&user_token='.$user_token.'&format=xml'; 
    $xmlData = simplexml_load_file($url); 
    foreach ($xmlData->item as $serie){
    	if ( "$serie->status" == "Watching" ) { 
    		$titulos[]=str_replace("\\","","$serie->title");
      	$caratulas[]="$serie->poster";
      	$serieref[]="http://series.ly/series/serie-"."$serie->idSerie";
      }
    }

    $lista = array ('titulo' => $titulos,'enlace' => $serieref, 'caratula' => $caratulas);
    $tipo = 'temporadas';
  }  

	else if ($queryData['inicio'] =='SeriesPendientes') {
  	$url = 'http://series.ly/api/userSeries.php?auth_token='.$auth_token.'&user_token='.$user_token.'&format=xml';
    $xmlData = simplexml_load_file($url);
    foreach ($xmlData->item as $serie){
    	if ( "$serie->status" == "Pending" ) {
      	$titulos[]=str_replace("\\","","$serie->title");
        $caratulas[]="$serie->poster";
        $serieref[]="http://series.ly/series/serie-"."$serie->idSerie";
      }
    }
        
    $lista = array ('titulo' => $titulos,'enlace' => $serieref, 'caratula' => $caratulas);
    $tipo = 'temporadas';
  }
  
	else if ($queryData['inicio'] =='SeriesFinalizadas') {
  	$url = 'http://series.ly/api/userSeries.php?auth_token='.$auth_token.'&user_token='.$user_token.'&format=xml';
    $xmlData = simplexml_load_file($url);
    foreach ($xmlData->item as $serie){
    	if ( "$serie->status" == "Finished" ) {
      	$titulos[]=str_replace("\\","","$serie->title");
        $caratulas[]="$serie->poster";
        $serieref[]="http://series.ly/series/serie-"."$serie->idSerie";
      }
    }
          
    $lista = array ('titulo' => $titulos,'enlace' => $serieref, 'caratula' => $caratulas);
    $tipo = 'temporadas';
  }
  
	else if ($queryData['busqueda']!='') {
		$xmlData = simplexml_load_file($queryData['busqueda']);
    foreach ($xmlData->item as $serie){
    	$titulos[]=str_replace("\\","","$serie->title". " - Temporadas ". "$serie->seasons" . " -  Episodios " . "$serie->episodes"); 
      $caratulas[]="$serie->poster";
      $serieref[]="http://series.ly/series/serie-"."$serie->idSerie";
    }

    $lista = array ('titulo' => $titulos,'enlace' => $serieref, 'caratula' => $caratulas); 
    $tipo = 'temporadas';
  } 

	else if ($queryData['temporadas'] !='') {
  	preg_match('/\/.*serie-(..........)/', $queryData['temporadas'], $idserie);
    file_put_contents( '/tmp/codserie' , $idserie[1]);
    $url = 'http://series.ly/api/detailSerie.php?auth_token='.$auth_token.'&idSerie='.$idserie[1].'&user_token='.$user_token.'&format=xml&caps=1';
    $xmlData = simplexml_load_file($url);
    $Poster="$xmlData->poster"; 
    foreach ($xmlData->episode->item as $episodio) {
    	preg_match('/(.*)x/',$episodio->season,$temporada);
      $Temp[]='Temporada '.$temporada[1];
      $Enl[]=$temporada[1];
    }

    $Temporadas[1]=array_keys(array_count_values(array_unique($Temp)));
    $Enlaces[1]=array_keys(array_count_values(array_unique($Enl)));
    foreach ($Enlaces[1] as $value) { $caratulas[] = $Poster;} 
   	$lista = array ('titulo' => $Temporadas[1],'enlace' => $Enlaces[1], 'caratula' => $caratulas,'serie' => "$xmlData->title",'url' => $queryData['temporadas']);
    $tipo = 'capitulos';
  } 
 
	else if ($queryData['capitulos']!='') {
  	$idserie=file_get_contents('/tmp/codserie');
    $url = 'http://series.ly/api/detailSerie.php?auth_token='.$auth_token.'&idSerie='.$idserie.'&user_token='.$user_token.'&format=xml&caps=1';
    $xmlData = simplexml_load_file($url); 
    $Poster="$xmlData->poster";
    foreach ($xmlData->episode->item as $episodio) {
    	preg_match('/(.*)x/',$episodio->season,$temporada);
      if ( $temporada[1] == $queryData['capitulos'] ) {
      	$Cap[]=$episodio->idc;
        if ($episodio->viewed == 1) {
        	$CapNom[]=str_replace("\\","","$episodio->title"." - (Visto)");
          $caratulas[]="http://i54.tinypic.com/24o0lsl.png";} 
        else { 
        	$CapNom[]=str_replace("\\","","$episodio->title");
          $caratulas[]=$Poster;
        }
      }
    }

    $NombreCaps[1]=array_keys(array_count_values(array_unique($CapNom)));
		$lista = array ('titulo' => $NombreCaps[1],'enlace' => $Cap, 'caratula' => $caratulas);
		$tipo = 'enlaces';
	}

	else if ($queryData['enlaces']!=''){
		$idserie=file_get_contents('/tmp/codserie');
    $url='http://series.ly/api/linksCap.php?auth_token='.$auth_token.'&idCap='.$queryData['enlaces'][0].'&user_token='.$user_token.'&format=xml';
    
    $xmlData = simplexml_load_file($url);

    foreach ($xmlData->item as $Links) {
    	if ( "$Links->host" == "putlocker" || "$Links->host" == "wupload" || "$Links->host" == "uploaded" || "$Links->host" == "vk" || "$Links->host" == "vkontakte"){
      	if ( "$Links->hd" == 0 ) {
        	$Enlace[]="Calidad: SD -- "."$Links->lang" . " -- Sub: ". "$Links->sub" . " -- Serv: " . "$Links->host";
          $caratulas[]="http://i52.tinypic.com/34g22d5.png";
        } 
        else {
          $Enlace[]="Calidad: HD -- "."$Links->lang" . " -- Sub: ". "$Links->sub" . " -- Serv: " . "$Links->host";
          $caratulas[]="http://i53.tinypic.com/35c0j6f.png";
        }
        $Cod_MV[]="$Links->url"."Servidor"."$Links->host";
      }
    }
 
    $lista = array ('titulo' => $Enlace,'enlace' => $Cod_MV, 'caratula' => $caratulas);
    $tipo = 'enlaceMV';
  }
  
	else if ($queryData['enlaceMV']!=''){
	  preg_match_all("/.*Servidor(.*)/",$queryData['enlaceMV'],$Server);    
	  preg_match_all("/(.*)Servidor/",$queryData['enlaceMV'],$UrlEnc);
	       
	  $header='Cookie: '.$mi_cookie.'\r\n';
	  $opts = array('http'=>array('method'=>"HEAD",'header'=> $header."\r\n")); 
	  $context = stream_context_create($opts);
	  $url = str_replace(' ','+',$UrlEnc[1][0]);
	  file_get_contents($url,false,$context);#Se pasa stream_context con la cookie en el header. Para obtener el enlace hay que estar logado. 
	
	  if ( $Server[1][0] == "putlocker" ) {        
	  	$servidor="Enlace PutLocker";  
	    $caratula="http://desihit.net/new/tv/PutLocker.png";
	    $bus_megavideo = preg_grep('/http:\/\/www.putlocker.com\/file\/.*/', $http_response_header);
	    $bus_megavideo[1] = array_keys(array_count_values($bus_megavideo)); 
	    preg_match_all("/.*http:\/\/www.putlocker.com\/file\/(................)/",$bus_megavideo[1][0],$mv); 
	    //GET Y GUARDAR COOKIES
	    $PagServ=file_get_contents('http://www.putlocker.com/file/'.$mv[1][0]);
	    preg_match_all('/.*input type="hidden" value="(................)" name="hash"/',$PagServ,$valorhash);
	    $bus_phpsessid = preg_grep('/PHPSESSID/', $http_response_header);
	    $bus_usender = preg_grep('/usender/', $http_response_header); 
	    $bus_phpsessid[1]=array_keys(array_count_values($bus_phpsessid));
	    $bus_usender[1]=array_keys(array_count_values($bus_usender));
	    preg_match('/Set-Cookie: (.*) .*path/',$bus_phpsessid[1][0],$PHPSESSID);
	    preg_match('/Set-Cookie: (.*) expires/',$bus_usender[1][0],$USENDER);
	    $cookiePutLocker=$PHPSESSID[1].$USENDER[1]; 
	    //POST CON COOKIES 
	    $postdata = http_build_query(array('hash' => $valorhash[1][0],'confirm' => '"Continue as Free User"'));
	    $opts = array('http' =>array('method'  => 'POST','header'  => 'Cookie: '.$cookiePutLocker,'content' => $postdata)); 
	    $context  = stream_context_create($opts);
	    $Salida=file_get_contents("http://www.putlocker.com/file/".$mv[1][0],false,$context); 
	    //GET DEL ENLACE FINAL DEL VIDEO 
	    preg_match_all("/.*playlist: ..get_file.php.stream=(.*)'.*/",$Salida,$flashvars); 
	    $opts1 = array('http'=>array('method'=>"GET",'header'=> 'Cookie: '.$cookiePutLocker));
	    $context1 = stream_context_create($opts1);
	    $link=file_get_contents("http://www.putlocker.com/get_file.php?stream=".$flashvars[1][0],false,$context1);
	    preg_match_all('/.*media:content url="(.*)" type/',$link,$url);  
	    $res=$url[1][0];        
	  }
	  if ( $Server[1][0] == "wupload" ) {
	  	$servidor="Enlace Wupload";
	    $caratula="http://lazonapremium.org/images/WUpload.png";
	    $bus_megavideo = preg_grep('/http:\/\/www.wupload.*\/file\/.*/', $http_response_header);
	    $bus_megavideo[1] = array_keys(array_count_values($bus_megavideo));
	    preg_match_all("/http:\/\/www.wupload.*\/file\/(..........)/",$bus_megavideo[1][0],$mv); 
	    $res='http://127.0.0.1/umsp/plugins/proxy_wupload.php?v='.$mv[1][0]; 
	  }  
	  if ( $Server[1][0] == "uploaded" ) {
	  	$servidor="Enlace Uploaded.to";
	    $caratula="http://2.bp.blogspot.com/-RtFqqDMQOeo/TxydmvI_suI/AAAAAAAA17E/Bd-qnkemPoY/s1600/uploaded.png";
	    $bus_megavideo = preg_grep('/http:\/\/uploaded.to\/file\/.*/', $http_response_header);
	    $bus_megavideo[1] = array_keys(array_count_values($bus_megavideo));
	    preg_match_all("/http:\/\/uploaded.to\/file\/(........)/",$bus_megavideo[1][0],$mv);
	    $res='http://127.0.0.1/umsp/plugins/proxy_uploaded.php?v='.$mv[1][0];
	  }
	  if ( $Server[1][0] == "vk"  || $Server[1][0] == "vkontakte") {		
			$caratula="http://cs9611.vk.com/u00021/98988/x_ed3c903a.jpg";
			if($Server[1][0] == "vkontakte"){
				$bus_megavideo = preg_grep('/http:\/\/vkontakte.ru\/.*/', $http_response_header);
		    $bus_megavideo[1] = array_keys(array_count_values($bus_megavideo)); 
		    preg_match_all("/.*http:\/\/vkontakte.ru\/(.*)/",$bus_megavideo[1][0],$mv); 	        
			}
			else{
				$bus_megavideo = preg_grep('/http:\/\/vk.com\/.*/', $http_response_header);
		    $bus_megavideo[1] = array_keys(array_count_values($bus_megavideo)); 
		    preg_match_all("/.*http:\/\/vk.com\/(.*)/",$bus_megavideo[1][0],$mv); 	        	        
			}							
			if(strpos('http://vk.com/'.$mv[1][0], "hash")){
				$PagServ=file_get_contents('http://vk.com/'.$mv[1][0]);
			}
			else{
				$pagetemp = file_get_contents('http://vk.com/'.$mv[1][0]);
				preg_match("/oid: ([^,]+),.*?/",$pagetemp,$oidtemp);					
				$idtemp=strstr('http://vk.com/'.$mv[1][0], "_");
				$idtemp = substr($idtemp,1);
				preg_match('/\\\"hash2\\\":\\\"(.*?)\\\"/',$pagetemp,$hashtemp);				
				$PagServ=file_get_contents("http://vk.com/video_ext.php?oid=" . $oidtemp[1] . "&hash=" . $hashtemp[1] . "&id=" . $idtemp);
			}
					
			preg_match("/video_host = '([^']+)'.*?/",$PagServ,$video_host);
			preg_match("/video_uid = '([^']+)'.*?/",$PagServ,$video_uid);
			preg_match("/video_vtag = '([^']+)'.*?/",$PagServ,$video_vtag);
			preg_match("/video_no_flv = ([^;]+);.*?/",$PagServ,$video_no_flv);
			preg_match("/video_max_hd = '([^']+)'/",$PagServ,$video_max_hd);		
					
			if( substr( $video_host[1], strlen( $video_host[1] ) - strlen( "/" ) ) != "/")
			{
				$video_host[1] = $video_host[1] . "/";
			}
				
			if ($video_no_flv[1] != "0")
			{
				for($i=0; $i <= $video_max_hd[1]; $i++){
					switch($i){
						case 0:
							$servidor[]="Enlace vk.com 240p";
							$urls[] = $video_host[1]."u".$video_uid[1]."/video/".$video_vtag[1].".240.mp4";
						break;
						case 1:
							$servidor[]="Enlace vk.com 360p";
							$urls[] = $video_host[1]."u".$video_uid[1]."/video/".$video_vtag[1].".360.mp4";
						break;
						case 2:
							$servidor[]="Enlace vk.com 480p";
							$urls[] = $video_host[1]."u".$video_uid[1]."/video/".$video_vtag[1].".480.mp4";
						break;
						case 3:
							$servidor[]="Enlace vk.com 720p";
							$urls[] = $video_host[1]."u".$video_uid[1]."/video/".$video_vtag[1].".720.mp4";
						break;
					}
				}				
			}
			$numero = sizeof($servidor);
	    for($j = 0; $j < $numero; $j++){
	    	$retMediaItems[] = array (
	      	'id' => 'umsp://plugins/peliculas-seriesly-api'.$j,
	        'dc:title' => $servidor[$j],
	        'res' => $urls[$j],
	        'upnp:class' => 'object.item.videoitem',
	        'upnp:album_art'=> $caratula,
	        'protocolInfo' => '*:*:*:*',);
	    }         
	    return $retMediaItems;
	  }
	  else{
	   //   if ( empty($url[1][0])){
	   //     $user_token=_NosLogamos();} ###La api esta un poco verde aqui. Es posible que previamente el isUserLogged.php nos haya identificado con sesion valida pero realmente no sea asi. Pasa muy pocas veces. En ese caso volvemos a logarnos.  
	   //   else {  
	
	    $retMediaItems[] = array (
	  		'id' => 'umsp://plugins/series-seriesly-api',
	      'dc:title' => $servidor,
	      'res' => $res,
	      'upnp:class' => 'object.item.videoitem',
	      'upnp:album_art'=> $caratula,
	      'protocolInfo' => '*:*:*:*',);
	         
	    return $retMediaItems;  
	  }
	}   
	else if ($queryData['favoritos'] !='') {
            return _pluginFavorito($queryData['favoritos'],$plugin);
  }
//Pagina Inicial
	else {

		$lista = array (
		'titulo' => array ('Siguiendo', 'Series Pendientes', 'Series Finalizadas'),
		'enlace' => array ('Siguiendo', 'SeriesPendientes', 'SeriesFinalizadas'),
		'caratula' => array ('http://i56.tinypic.com/2zqt2fq.png','http://i54.tinypic.com/5vu8ag.png','http://i53.tinypic.com/t8ogg8.png'),
		);
	
		$tipo = 'inicio';
	}
	return _CrearItems($lista,$plugin,$tipo);
}

//Funciones
function _cadenaBusqueda(){
        $auth_token=file_get_contents('http://series.ly/api/auth.php?api=16&secret=7F3Ff9PeVu7ch3vTPZ93');
        return 'http://series.ly/api/search.php?auth_token='.$auth_token.'&type=serie&format=xml&search=';}
?>